
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>C# 设计模式系列教程-装饰模式_C#教程 / iVAN</title>

    <meta name="description" content="C# 设计模式系列教程-装饰模式_C#教程 1. 概述 动态地给一个对象添加一些额外的职责,就增加功能来说,装饰模式比生成子类更灵活. 原理:增加一个修饰类包裹原来的类,包裹的方式一般是通过在将原来的对象作为修饰类的构造函数的参数.装饰类实现新的功能,但是,在不需要用到新功能的地方,它可以直接调用原来的类中的方法.修饰类必须和原来的类有相同的接口. 2. 模式中的角色 2.1 抽象构建(Component):定义一个抽象接口,用以给这些对象动态地添加职责. 2.2 具体构建(ConcreteComponent):定义一个具体的对象,也可以">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">C# 设计模式系列教程-装饰模式_C#教程</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p><strong>1. 概述</strong></p>
<p>　　动态地给一个对象添加一些额外的职责，就增加功能来说，装饰模式比生成子类更灵活。</p>
<p>　　原理：增加一个修饰类包裹原来的类，包裹的方式一般是通过在将原来的对象作为修饰类的构造函数的参数。装饰类实现新的功能，但是，在不需要用到新功能的地方，它可以直接调用原来的类中的方法。修饰类必须和原来的类有相同的接口。</p>
<p><strong>2. 模式中的角色</strong></p>
<p>　　2.1 抽象构建（Component）：定义一个抽象接口，用以给这些对象动态地添加职责。</p>
<p>　　2.2 具体构建（ConcreteComponent)：定义一个具体的对象，也可以给这个对象添加一些职责。</p>
<p>　　2.3 装饰类（Decorator): 装饰抽象类，继承了Component,从外类来扩展Component类的功能。</p>
<p>　　2.4 具体装饰者（ConcretorDecorator)：负责给构建对象添加职责。</p>
<p><strong>3. 模式解读</strong></p>
<p>　　3.1 装饰模式的一般化类图</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MDYwMTExMzkyNjI5LnBuZw==.jpg"></p>
<p>　　3.2 装饰模式的一般化代码</p>
<pre>
 /// &lt;summary&gt;
 /// 定义一个对象接口，可以给这些对象动态地添加职责
 /// &lt;/summary&gt;
 public abstract class Component
 {
  public abstract void Opration();
 }

 /// &lt;summary&gt;
 /// 具体对象
 /// &lt;/summary&gt;
 public class ConcreteComponent:Component
 {

  public override void Opration()
  {
   // 具体对象的操作
  }
 }

 /// &lt;summary&gt;
 /// 抽象的装饰类，它不能初始化对象。
 /// &lt;/summary&gt;
 public abstract class Decorator:Component
 {
  protected Component component;

  /// &lt;summary&gt;
  /// 设置Component
  /// &lt;/summary&gt;
  /// &lt;param name="component"&gt;&lt;/param&gt;
  public void SetComponent(Component component)
  {
   this.component = component;
  }

  /// &lt;summary&gt;
  /// 重写Operation，实际执行的是Component的Operation。
  /// &lt;/summary&gt;
  public override void Opration()
  {
   if (component != null)
   {
    component.Opration();
   }
  }
 }

 public class ConcreteDecoratorA : Decorator
 {
  private void SpecialOpration()
  {
   // 本类特有的功能
  }

  public override void Opration()
  {
   //首先运行原Component的Operation(),在执行本类的功能，相当于对原Component进行了装饰
   base.Opration();

   this.SpecialOpration();
  }
 }

 public class ConcreteDecoratorB : Decorator
 {
  private void SpecialOprationA()
  {
   // 本类特有的功能 A
  }

  private void SpecialOprationB()
  {
   // 本类特有的功能 B
  }

  public override void Opration()
  {
   //首先运行原Component的Operation(),在执行本类的功能，相当于对原Component进行了装饰
   base.Opration();

   this.SpecialOprationA();
   this.SpecialOprationB();
  }
 }
</pre>
<p><strong>4. 模式总结</strong></p>
<p>　　4.1 优点</p>
<p>　　　　4.1.1 每个装饰对象只关心自己的功能，不需要关心如何被添加到对象链当中。它是由Decorator的SetComponent方法来实现的，因而它们的职责是单一的。</p>
<p>　　　　4.1.2 类的核心职责与动态添加的职责是分离的。如果再向主类中添加新的功能，一是违反了开放封闭原则，二是增加了主类的复杂度。</p>
<p>　　　　4.1.3 比静态继承更灵活 与对象的静态继承相比，Decorator模式提供了更加灵活的向对象添加职责的方式，可以使用添加和分离的方法，用装饰在运行时刻增加和删除职责.</p>
<p>　　4.2 缺点</p>
<p>　　　　4.2.1 产生许多小对象，采用Decorator模式进行系统设计往往会产生许多看上去类似的小对象，这些对象仅仅在他们相互连接的方式上有所不同。</p>
<p>　　4.3 适用场景</p>
<p>　　　　4.3.1 当需要为已有功能动态地添加更多功能时。</p>
<p>　　　　4.3.2 类的核心功能无需改变，只是需要添加新的功能时。</p>
<p><strong>5. 应用实例：装备大兵！无任何装备时（核心功能）可以用拳脚搏击；装备了步枪，可以正常射击；装备了重机枪，可以扫射；装备了火箭筒，可以防空。</strong></p>
<p>　　5.1 类图设计</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MDYwMTExMzkyNjMyLnBuZw==.jpg"></p>
<p>　　5.2 代码实现</p>
<pre>
 /// &lt;summary&gt;
 /// 装备类，相当于Component
 /// &lt;/summary&gt;
 public abstract class Equipment
 {

  public abstract void Attack();
 }

 /// &lt;summary&gt;
 /// 士兵类，继承自Equipment
 /// &lt;/summary&gt;
 public class Soldier : Equipment
 {
  public Soldier()
  {
   // 构造函数
  }

  /// &lt;summary&gt;
  /// 没有任何武器装备下的核心功能
  /// &lt;/summary&gt;
  public override void Attack()
  {
   Console.WriteLine("用拳脚攻击！");
  }
 }

 public abstract class EquipDecorator : Equipment
 {
  protected Equipment equipment;

  /// &lt;summary&gt;
  /// 增加装备，使用该方法来动态地给士兵增加装备
  /// &lt;/summary&gt;
  /// &lt;param name="equipment"&gt;&lt;/param&gt;
  public void SetComponent(Equipment equipment)
  {
   this.equipment = equipment;
  }

  /// &lt;summary&gt;
  /// 攻击
  /// &lt;/summary&gt;
  public override void Attack()
  {
   //如果有装备，就用装备进行攻击
   if (equipment != null)
   {
    equipment.Attack();
   }
  }
 }

 /// &lt;summary&gt;
 /// 步枪
 /// &lt;/summary&gt;
 public class RifleEquipment : EquipDecorator
 {
  public override void Attack()
  {
   base.Attack();

   Console.WriteLine("步枪射击，啪！");
  }
 }

 /// &lt;summary&gt;
 /// 机枪
 /// &lt;/summary&gt;
 public class MachineGunEquipment : EquipDecorator
 {
  public override void Attack()
  {
   base.Attack();

   Console.WriteLine("机枪扫射，突突突！");
  }
 }

 /// &lt;summary&gt;
 /// 火箭筒
 /// &lt;/summary&gt;
 public class RocketGunEquipment : EquipDecorator
 {
  public override void Attack()
  {
   base.Attack();

   Console.WriteLine("火箭炮射击，唰......！");
  }
 }
</pre>
<p>　　5.3 客户端调用</p>
<pre>
 class Program
 {
  static void Main(string[] args)
  {
   // 定义新兵
   Soldier soldier = new Soldier();

   // 三种装备
   RifleEquipment rifle = new RifleEquipment();
   MachineGunEquipment machineGun = new MachineGunEquipment();
   RocketGunEquipment rocketGun = new RocketGunEquipment();

   // 将三种装备全部交给新兵
   rifle.SetComponent(soldier);
   machineGun.SetComponent(rifle);
   rocketGun.SetComponent(machineGun);

   // 攻击，除了拳脚功夫外，新兵还可以使用步枪，机枪，火箭炮.最终执行的是rocketGun.Attack().
   rocketGun.Attack();

   Console.Read();
  }
 }
</pre>
<p>　　5.4 运行结果</p>
<p>　　用拳脚攻击！<br />
　　步枪射击，啪！<br />
　　机枪扫射，突突突！<br />
　　火箭炮射击，唰......！</p>
<p>以上就是本文的全部内容，希望能给大家一个参考，也希望大家多多支持。</p>
<p>以上是小编为您精心准备的的内容，在的博客、问答、公众号、人物、课程等栏目也有的相关内容，欢迎继续使用右上角搜索按钮进行搜索c#<br />
                    ，                接口<br />
                    ，                设计模式<br />
                    ，                抽象<br />
                                    装饰模式<br />
                                    c站、c语言、cf、ch、c罗，以便于您获取更多的相关知识。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-23 11:19:32</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e6%8e%a5%e5%8f%a3/" title="接口">接口</a>, <a href="https://www.iamivan.net/tag/%e6%8a%bd%e8%b1%a1/" title="抽象">抽象</a>, <a href="https://www.iamivan.net/tag/%e8%ae%be%e8%ae%a1%e6%a8%a1%e5%bc%8f/" title="设计模式">设计模式</a>, <a href="https://www.iamivan.net/tag/%e8%a3%85%e9%a5%b0%e6%a8%a1%e5%bc%8f/" title="装饰模式">装饰模式</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>C# 设计模式系列教程-装饰模式_C#教程的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zDeqPlb.html" rel="bookmark">C&num; 设计模式系列教程-适配器模式&lowbar;C&num;教程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1. 概述 将一个类的接口转换成客户希望的另外一个接口.Adapter模式使得原本由于接口不兼容而不能一起工作的那些类可以在一起工作. 2. 解决的问题 即Adapter模式使得原本由于接口不兼容而不能一起工作的那些类可以在一起工作. 3. 模式中的角色 3.1 目标接口(Target):客户所期待的接口.目标可以是具体的或抽象的类,也可以是接口. 3.2 需要适配的类(Adaptee):需要适配的类或适配者类. 3.3 适配器(Adapter):通过包装一个需要适配的对象,把原接口转换成目标接			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M0NYvJz.html" rel="bookmark">C&num; 设计模式系列教程-单例模式&lowbar;C&num;教程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1. 描述: 保证一个类仅有一个实例,并提供一个访问它的全局访问点. 2. 单例模式主要有3个特点,: 2.1 单例类确保自己只有一个实例. 2.2 单例类必须自己创建自己的实例. 2.3 单例类必须为其他对象提供唯一的实例. 3. 实现方式:懒汉单例类和饿汉单例类 3.1 懒汉式单例类 对于懒汉模式,我们可以这样理解:该单例类非常懒,只有在自身需要的时候才会行动,从来不知道及早做好准备.它在需要对象的时候,才判断是否已有对象,如果没有就立即创建一个对象,然后返回,如果已有对象就不再创建,立即返			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pn6VGOp.html" rel="bookmark">c&num;设计模式 适配器模式详细介绍&lowbar;C&num;教程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				后续内容将包括以下结构模式: 适配器模式(Adapter):Match interfaces of different classes合成模式(Composite):A tree structure of simple and composite objects装饰模式(Decorator):Add responsibilities to objects dynamically代理模式(Proxy):An object representing another object享元模式(Flywei			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bKq0A5p.html" rel="bookmark">&period;Net WInform开发笔记&lpar;二&rpar;Winform程序运行结构图及TCP协议在Winform中的应用&lowbar;C&num;教程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				中午没事,把去年刚毕业那会画的几张图翻出来了,大概介绍Winform应用程序运行的过程,以及TCP协议在Winform中的应用.如果有Windows消息机制等基础,很好理解这两张图. (1)Winform应用程序运行结构图 开发笔记(二)Winform程序运行结构图及TCP协议在Winform中的应用_C#教程-tcp ip协议 层结构图&quot;&gt; (2)TCP通讯协议在Winform程序中的应用示意图 熟悉整个程序的来龙去脉,编程的时候就会很轻松,不会云里雾里. 另附公司招聘面试题一份,用了几			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p5ZmNmz.html" rel="bookmark">使用VS2010 C&num;开发ActiveX控件&lpar;下&rpar;&comma;完整代码打包下载&lowbar;C&num;教程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				其实如果我们不进行设置,只是修改了代码,运行程序以后,其出错界面如下图1所示: 开发ActiveX控件(下),完整代码打包下载_C#教程-vs2010使用教程 c&quot;&gt; 图1 抛出异常如下: ************** Exception Text ************** System.MethodAccessException: Attempt by security transparent method 'Rare.Card.Libary.Controls. ReadCardCo			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MYNdy5p.html" rel="bookmark">&period;Net WInform开发笔记&lpar;三&rpar;谈谈自制控件&lpar;自定义控件&rpar;&lowbar;C&num;教程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				末日这天写篇博客吧,既然没来,那就纪念一下. 这次谈谈自制控件,也就是自定义控件,先上图,再说 1.扩展OpenFileDialog,在OpenFileDialog中添加各种文件(.txt,.jpg,.excel等等)的预览功能 开发笔记(三)谈谈自制控件(自定义控件)_C#教程-winform自定义控件&quot;&gt; 2.重写ListBox,增加折叠.鼠标背影.分类等功能 -----------------------------分割线-------------------------------			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pkGXLyp.html" rel="bookmark">大话设计模式系列</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:大话设计模式系列 1.设计模式之前奏(UML类图) 2.设计模式之一(单例模式) 3.设计模式之二(简单工厂模式) 4.设计模式之三(工厂方法模式) 5.设计模式之四(抽象工厂模式第一回合) 6.设计模式之四(抽象工厂模式 第二回合) 7.设计模式之四(抽象工厂模式 第三回合) 8.设计模式原则(单一.开放封 闭.里氏代换.依赖倒转.迪米特法则五大原则) 9.设计模式之五(策略模式) 10.设计模式之六(装饰模式) 11.设计模式之七(代理模式) 12.设计模式之八(原型模式) 13.设计			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pP8wG8p.html" rel="bookmark">Windows 2003 IIS6&plus;PHP5&plus;MySQL5&plus;Zend环境搭建图文教程-最新新手教程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				中介交易 SEO诊断 淘宝客 云主机 技术大厅 Windows 2003 IIS6+PHP5+MySQL5+Zend环境搭建图文教程 最新新手教程 一.系统约定环境软件下载后存放位置:D:\ServerSoft 环境软件安装位置:D:\ServerRoot PHP安装位置:D:\ServerRoot\PHP MySQL安装位置:D:\ServerRoot\MySQL Zend Optimizer安装位置:D:\ServerRoot\Zend IIS网站站点根目录:D:\wwwroot MySQL			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mg32y3M.html" rel="bookmark">Android设计模式系列之工厂方法模式&lowbar;Android</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				工厂方法模式,往往是设计模式初学者入门的模式,的确,有人称之为最为典型最具启发效果的模式. android中用到了太多的工厂类,其中有用工厂方法模式的,当然也有很多工厂并不是使用工厂方法模式的,只是工具管理类. 今天以ThreadFactory举例说明一下简单工厂模式和工厂方法模式. 工厂方法模式,Factory Method,简单的方式,不简单的应用. 1.意图 定义一个用于创建对象的接口,让子类决定实例化哪个类.工厂方式模式使一个类的实例化延迟到其子类. 热门词汇:虚构造器 延迟 创建对象			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Lp5mqnp.html" rel="bookmark" class="title">一个可以读取ID3信息的类&lbrack;可以很方便添加MP3了&rsqb;</a>
					<div>
						&lt;!--METADATA TYPE=&quot;typelib&quot; UUID=&quot;00000205-0000-0010-8000-00AA006D2EA4&quot; NAME= ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Lp5LERM.html" rel="bookmark" class="title">rephactor 优秀的PHP的重构工具</a>
					<div>
						PHP框架可以是单一入口,完全面向对象的,完全基于类的MVC模式.但是,我们面对大量的旧的代码,或即便是新的代码,也不尽然完全符合面向对象的原则,符合设计模式.小的应用无妨.但如果面对大型应用,则必然 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Lp5y8Bp.html" rel="bookmark" class="title">PHP无限级分类查找父层函数</a>
					<div>
						函数 如: classID          classFID          className          classCount      1                  0     ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/VzwaARM.html" rel="bookmark" class="title">ASP文章系统解决方案</a>
					<div>
						首先感谢V37斑竹对我的帮助,这个方案解决了显示&quot;上一篇下一篇&quot;和相关文章的问题, 贴出来让大家分享. 以前看到一个帖子讲用ID+1和ID-1的办法判断&quot;上一篇下一篇&q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/yMAg6vz.html" rel="bookmark" class="title">在ASP中用EasyMailObject组件处理Exchange邮件源代码&lpar;1&rpar;</a>
					<div>
						object|源代码 读取邮件主题和大小(maillist1.asp)&lt;%@ LANGUAGE=&quot;VBSCRIPT&quot; %&gt;&lt;%'***************** ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bj7wL5M.html" rel="bookmark" class="title">Unix的入侵追踪</a>
					<div>
						在*NIX系统遭受入侵后,确定损失及入侵者的攻击源地址相当重要.虽然在大多数入侵者懂得使用曾被他们攻陷的机器作为跳板来攻击你的服务器可在他们发动正式攻击前所做的目标信息收集工作(试探性扫描)常常是从他 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW174Ez.html" rel="bookmark" class="title">Photoshop色阶调整图像操作2：轻轻松松点吸管</a>
					<div>
											</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvK56Wp.html" rel="bookmark" class="title">C&plus;&plus; Builder中MDI应用程序的设计</a>
					<div>
						MDI(多文档界面)应用程序是指用户可以同时打开多个文档,每一个文档显示在应用程序主窗口客户区的独立窗口中.如字处理程序Word就是一个典型的MDI应用程序,你可以在Word中同时打开和使用多个文档, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGjy6vp.html" rel="bookmark" class="title">Shell中函数返回值超出问题</a>
					<div>
						  这篇文章主要介绍了Shell中函数返回值超出问题,shell中通过return返回是有限制的,最大返回255,超过255,则从0开始计算,需要的朋友可以参考下 1.前言 快半年没有写博客了,荒废了 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvG5d8p.html" rel="bookmark" class="title">米聊PC版试用笔记 能否媲美QQ？</a>
					<div>
						小米公司宣布收购MSNLite之后的第一个大动作就是推出了米聊的PC客户端,在手机平台上取得不错成绩后,米聊将目光转向了PC桌面,并不规避与腾讯的竞争,与QQ.微信展开正面较量.今天,米聊PC版开始了 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXjmNjb.html" rel="bookmark" class="title">笔记本屏幕花屏的原因和解决技巧</a>
					<div>
						  1.驱动问题,多出现于更换显卡驱动版本之后,也有可能是因为驱动文件损坏所导致.解决的办法很简单,重装通过微软WHQL认证的驱动,版本没有必要一味求新. 2.显示卡的主控芯片散热效果不良,不仅仅是因 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mg3XYBM.html" rel="bookmark" class="title">如何禁用写入U盘功能</a>
					<div>
						  u盘相信大家都不陌生了,由于U盘的体积小.重要轻这些特点受到大家的欢迎,但也正因为U盘这些特点,很多人也担心在自己的电脑上的重要资料会被不知不觉中复制走,但又不能禁用U盘,那有没有什么办法让U盘变 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9Y1Y4M.html" rel="bookmark" class="title">JavaScript中按位&OpenCurlyDoubleQuote;异或&rdquo;运算符使用介绍&lowbar;javascript技巧</a>
					<div>
						按位&quot;异或&quot;运算符 (^)是对两个表达式执行按位异或.使用方法: 复制代码 代码如下: result = expression1 ^ expression2 其中result是任何 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bE6ZELM.html" rel="bookmark" class="title">IDC：无线数字化转型持续进行 第二季度全球企业WLAN市场强劲增长</a>
					<div>
						根据IDC的全球WLAN季度追踪报告显示,2017年第二季度全球消费级和企业级无线局域网(WLAN)综合市场同比增长2.5%,达到23.7亿美元.企业市场部分在该季度同比增长9.4%,达到14.8亿美 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPP71Dp.html" rel="bookmark" class="title">echarts 图表-echarts ie7兼容性问题</a>
					<div>
						问题描述 echarts ie7兼容性问题 ie7的echarts工具栏的按钮,不停闪烁,点击不能响应事件,多次点击,偶尔会响应一次!这是什么原因导致的,大神求教啊!! 解决方案 Cognos 8.3 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zV0N3mM.html" rel="bookmark" class="title">vs2010 能否作为azure 开发平台</a>
					<div>
						问题描述 vs2010 能否作为azure 开发平台 Windows Azure提供了丰富的工具和软件开发包,来方便用户开发.测试和发布应用程序.Windows Azure的多数工具都被集成到了微软的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6ZqENM.html" rel="bookmark" class="title">零售终端来了新管家</a>
					<div>
						向上与运营商利益共享,向下向客户收取服务费 姜蓉 快车道WAY 日前,国内一专注于&quot;企业终端资源运营&quot;的专业服务商--至德讯通,获得了来自戈壁合伙人有限公司千万元级别的风险投资.这 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeRl4xb.html" rel="bookmark" class="title">袋鼠云日志，日志分析没那么容易</a>
					<div>
						从决定做袋鼠云的那一天,我就在思考,做为一家云计算和大数据的技术服务公司,做什么样的产品能给客户提供价值? 从2012年开始,我一直在做一个移动日志分析产品,类似于友盟和TalkingData,不过因 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MY5o69M.html" rel="bookmark" class="title">马云点中大数据产业 千亿金矿望浮现</a>
					<div>
						无论是收购高德,还是在十周年的晚会卸任演讲中,马云的嘴边都没有离开大数据.而根据国际公司IDC的调查报告,全球大数据产业未来3年之内还将出现200%的累计增长,市场规模超1460亿人民币,其整体增速约 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z40x3Nz.html" rel="bookmark" class="title">中联重科：思想构筑未来</a>
					<div>
						策划/鲍晓玉 何玉梅 执行/孙坚 郭洪业 王法艇 中联重科17年的沉潜厚蓄,可谓是一部极具典型意义的民族机械企业的创业史,砥砺并引领了中国工程机械行业的创新与发展.中联重科,每一次淬炼和嬗变的背后都彰 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgR1lZb.html" rel="bookmark" class="title">c语言问题-求助C语言代码中的问题</a>
					<div>
						问题描述 求助C语言代码中的问题 #include #include void main() { void input(char *name[],int n); void sort(char *nam ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8AWAZz.html" rel="bookmark" class="title">新版ASP&period;NET会在Visual Studio2015社区技术预览中呈现先行版</a>
					<div>
						摘要: 微软云计算和企业部门负责人.ASP.NET 之父,同时也是微软开源的主推手 Scott Guthrie,在他的博客发布了 ASP.NET 5. 本次发布的新版 ASP.NET 会在刚上线的 V ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5REwBz.html" rel="bookmark" class="title">【转】五笔字根图</a>
					<div>
						好久没有添加新文章了 因为从今天开始学打五笔,就贴张五笔字根图好了 很简单的,按我说的做,你可以在几个小时内入门,当然,你不要指望一天就能打得比拼音快,要想快起来,还得多练习.         五笔入 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDnLe0M.html" rel="bookmark" class="title">如何用正则筛选出123456</a>
					<div>
						问题描述 如何用正则筛选出123456,这两种情况.http://127.0.0.1:8080/Image/123456.JPGhttp://127.0.0.1:8080/Image/123456 解 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlLPlqM.html" rel="bookmark" class="title">大势所趋 ARM服务器市场渗透率呈现加速态势</a>
					<div>
						http://www.aliyun.com/zixun/aggregation/13453.html&quot;&gt;ARM服务器的市场渗透率呈现加速态势,主流服务器厂商纷纷推出基于ARM架构的微服 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9xKdRb.html" rel="bookmark" class="title">分类信息网站的用户数量决定前途</a>
					<div>
						中介交易 SEO诊断 淘宝客 云主机 技术大厅 分类信息市场需要培育---这是前不久在分类信息行业峰会上,口碑网CEO李治国.酷讯CEO陈华等国内分类信息领军人物不约而同的看法.培育的目的,无非是扩大 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqW59kz.html" rel="bookmark" class="title">JS的replace方法详细介绍&lowbar;javascript技巧</a>
					<div>
						replace() 方法的参数 replacement 可以是函数而不是字符串.在这种情况下,每个匹配都调用该函数,它返回的字符串将作为替换文本使用.该函数的第一个参数是匹配模式的字符串.接下来的参数 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW7PqrM.html" rel="bookmark" class="title">&period;net response&period;write 位置控制</a>
					<div>
						问题描述 在写一个自动考试系统的自动生成试卷中,从数据库中读出该试卷所有题型,在前端输出相应的试题,试题已从数据库中读出放在datatable中,但是不同的题输出的时候格式不一样,我用response ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPWkxDM.html" rel="bookmark" class="title">以微博为代表的互动类社区正在推动新的互联网革命</a>
					<div>
						越来越多的人在生活和工作中广泛使用微博,其互动性.即时性非常强,几乎消除了传播的过程,不仅让消息的 &quot; 流通 &quot; 变得极为快速便捷,也给许多传统媒体感受到带来新的冲击,都纷纷开始调 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zenZq7b.html" rel="bookmark" class="title">索尼聘请美国国土安全部资深人士担任安全主管</a>
					<div>
						美国国土安全部资深人士菲利普•雷丁格 新浪科技讯 北京时间9月7日上午消息,据美国科技博客Mashable报道,索尼已聘请美国国土安全部资深人士菲利普•雷丁格(Philip Reitinger)担任其 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.033 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
